import {Observable} from 'rxjs';
import {PayPalButtonStyle} from '../models/paypal-button-style.model';
import {BraintreeAssets, CheckoutData} from '../models/braintree-payment-data.model';

export abstract class PaymentAdapter{

  abstract loadPaymentDetails(
    paymentMethod: string,
    userId: string,
    cartId?: string
  ): Observable<CheckoutData>;

  abstract getPayPalButtonStyles(
    userId: string,
    buttonType?: string
  ): Observable<PayPalButtonStyle>;

  abstract getBraintreeAssets(): Observable<BraintreeAssets>;

}
