import {Observable} from 'rxjs';
import {Injectable} from '@angular/core';
import {PayPalButtonStyle} from '../models/paypal-button-style.model';
import {BraintreeAssets, CheckoutData} from '../models/braintree-payment-data.model';
import {PaymentAdapter} from './payment.adapter';

@Injectable()
export class BraintreePaymentConnector{
  constructor(protected adapter: PaymentAdapter) {}

  loadPaymentDetails(
    paymentMethod: string,
    userId: string,
    cartId?: string
  ): Observable<CheckoutData> {
    return this.adapter.loadPaymentDetails(paymentMethod, userId, cartId);
  }

  getPayPalButtonStyles(
    userId: string,
    buttonType?: string,
  ): Observable<PayPalButtonStyle>{
    return this.adapter.getPayPalButtonStyles(userId, buttonType);
  }

  getBraintreeAssets(): Observable<BraintreeAssets>{
    return this.adapter.getBraintreeAssets();
  }


}
