export const braintree = {
  error: {
    provider: 'Error during connect with payment provider. Reason: {{ reason }}',
    unsecuredCard: 'This card is unsecured. You should use another payment method.',
    authorization: {
      client: 'Error during connect with payment provider. Reason: Authorization failed.',
      failed: 'We are sorry but your transaction could not be completed at this time; please try again later or contact customer service at 555-555-5555'
    },
    address: {
      provide: 'You must provide a delivery address in order to go to the next step.'
    },

    hosted_fields_fields_empty: 'All fields are empty. Cannot tokenize empty card fields.',
    hosted_fields_fields_invalid: 'Some payment input fields are invalid. Cannot tokenize invalid card fields.',
    hosted_fields_failed_tokenization: 'The supplied card data failed tokenization.',
    hosted_fields_tokenization_network_error: 'A tokenization network error occurred.',
    client_request_timeout: 'Request timed out waiting for a reply.',
    client_gateway_network: 'Cannot contact the gateway at this time.',
    client_request_error: 'There was a problem with your request.',
    client_missing_gateway_configuration: 'Missing gatewayConfiguration.',
    paypal_account_tokenization_failed: 'Could not tokenize user\'s PayPal account.',
    paypal_invalid_payment_option: 'PayPal payment options are invalid',
    paypal_flow_failed: 'Could not initialize PayPal flow',
    paypal_browser_not_supported: 'This browser is not',
    paypal_flow_option_required: 'PayPal flow property is invalid or missing.',
    lpm_payment_failed: 'Sorry, we weren\'t able to complete your payment',
  },
  paymentDetails: {
    save: 'Save Payment Info',
    add: 'Add Payment Details',
    paymentDetails: 'Payment Details',
    cancelCreation: 'Back to Payment Details',
    noSaved: 'No Saved Payment Details',
    defaultPaymentMethod: 'Default Payment Method',
    noPaymentDetailsAvailable: 'No payment methods available'
  },
  orderDetails: {

    orderId: 'Order #',
    replenishmentId: 'Replenishment #',
    purchaseOrderId: 'Purchase Order #',
    emptyPurchaseOrderId: 'None',
    none: 'None {{value}}',
    placed: 'Placed',
    placedBy: 'Placed By',
    unit: 'Unit',
    costCenter: 'Cost Center',
    costCenterAndUnit: 'Cost Center / Unit',
    costCenterAndUnitValue: '{{costCenterName}} / {{unitName}}',
    payByAccount: 'Pay by Account',
    paidByCreditCard: '(paid by credit card)',
    status: 'Status',
    shippedOn: 'Shipped on',
    startOn: 'Start On',
    nextOrderDate: 'Next Order Date',
    frequency: 'Frequency',
    cancelled: ' Cancelled',
    deliveryStatus_IN_TRANSIT: 'In Transit',
    deliveryStatus_READY_FOR_PICKUP: 'Ready for Pickup',
    deliveryStatus_READY_FOR_SHIPPING: 'Ready for Shipping',
    deliveryStatus_WAITING: 'Waiting',
    deliveryStatus_DELIVERING: 'Delivering',
    deliveryStatus_PICKPACK: 'Preparing for Shipment',
    deliveryStatus_PICKUP_COMPLETE: 'Pickup Complete',
    deliveryStatus_DELIVERY_COMPLETED: 'Delivery Complete',
    deliveryStatus_PAYMENT_NOT_CAPTURED: 'Payment Issue',
    deliveryStatus_READY: 'In Process',
    deliveryStatus_DELIVERY_REJECTED: 'Delivery Rejected',
    deliveryStatus_SHIPPED: 'Shipped',
    deliveryStatus_TAX_NOT_COMMITTED: 'Tax Issue',
    deliveryStatus_CANCELLED: 'Cancelled',
    statusDisplay_cancelled: 'Cancelled',
    statusDisplay_cancelling: 'Cancel Pending',
    statusDisplay_completed: 'Completed',
    statusDisplay_created: 'Created',
    statusDisplay_error: 'Pending',
    statusDisplay_Error: 'Pending',
    statusDisplay_processing: 'Pending',
    statusDisplay_open: 'Open',
    statusDisplay_pending: {
      approval: 'Pending Approval',
      merchant: {
        approval: 'Pending Merchant Approval',
      },
    },
    statusDisplay_approved: 'Approved',
    statusDisplay_rejected: 'Rejected',
    statusDisplay_merchant: {
      approved: 'Merchant Approved',
      rejected: 'Merchant Rejected',
    },
    statusDisplay_assigned: {
      admin: 'Assigned To Administrator',
    },
    consignmentTracking: {
      action: 'Track package',
      dialog: {
        header: 'Tracking Information',
        shipped: 'Shipped',
        estimate: 'Estimated Delivery',
        carrier: 'Delivery Service',
        trackingId: 'Tracking Number',
        noTracking:
            'The package has not been dispatched from the warehouse. The tracking information will be available after the package is shipped.',
        loadingHeader: 'Consignment Tracking',
      },
    },
    cancellationAndReturn: {
      returnAction: 'Request a Return',
      cancelAction: 'Cancel Items',
      item: 'Item',
      itemPrice: 'Item Price',
      quantity: 'Max Quantity',
      returnQty: 'Quantity to Return',
      cancelQty: 'Quantity to Cancel',
      setAll: 'Set all quantities to maximum',
      totalPrice: 'Total',
      submit: 'Submit Request',
      returnSuccess: 'Your return request ({{rma}}) was submitted',
      cancelSuccess:
          'Your cancellation request was submitted (original order {{orderCode}} will be updated)',
    },
    cancelReplenishment: {
      title: 'Cancel Replenishment',
      description: 'Cancel any future replenishment order?',
      accept: 'Yes',
      reject: 'No',
      cancelSuccess:
          'Replenishment order #{{replenishmentOrderCode}} has been successfully cancelled',
    },
    statusDisplay_reversed: 'Local Payment Reversed',
  },
  address: {
    addresses: 'Addresses',
    select: 'Select address',
  }
};
