/**
 *
 */
package com.braintree.validators;

import de.hybris.platform.webservicescommons.errors.exceptions.WebserviceValidationException;
import org.springframework.validation.BeanPropertyBindingResult;
import org.springframework.validation.Errors;
import org.springframework.validation.Validator;

public interface BrainTreeValidator  extends Validator{

    default void validate(final Object object, final String objectName, final Validator validator)
    {
        final Errors errors = new BeanPropertyBindingResult(object, objectName);
        validator.validate(object, errors);
        if (errors.hasErrors())
        {
            throw new WebserviceValidationException(errors);
        }
    }
}
