package com.braintree.validators;

import com.braintree.hybris.data.ws.PayPalPaymentRequestWsDTO;
import org.springframework.util.Assert;
import org.springframework.validation.Errors;
import org.springframework.validation.ValidationUtils;
import org.springframework.validation.Validator;

import static com.braintree.constants.BraintreeoccaddonWebConstants.FIELD_REQUIRED_MESSAGE_ID;

public class PayPalPaymentRequestValidator implements BrainTreeValidator {

    private Validator payPalDetailsValidator;

    @Override
    public boolean supports(final Class clazz) {
        return PayPalPaymentRequestWsDTO.class.isAssignableFrom(clazz);
    }

    @Override
    public void validate(final Object target, final Errors errors) {

        final PayPalPaymentRequestWsDTO paymentResponse = (PayPalPaymentRequestWsDTO) target;

        ValidationUtils.rejectIfEmptyOrWhitespace(errors, "nonce", FIELD_REQUIRED_MESSAGE_ID);
        ValidationUtils.rejectIfEmptyOrWhitespace(errors, "type", FIELD_REQUIRED_MESSAGE_ID);

        Assert.notNull(paymentResponse.getDetails(), "Details object must not be null");
        validate(paymentResponse.getDetails(), "details", getPayPalDetailsValidator());
    }

    public Validator getPayPalDetailsValidator() {
        return payPalDetailsValidator;
    }

    public void setPayPalDetailsValidator(Validator payPalDetailsValidator) {
        this.payPalDetailsValidator = payPalDetailsValidator;
    }
}
